'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PanelMenuItem = exports.PanelMenu = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PanelMenu = exports.PanelMenu = function (_Component) {
    _inherits(PanelMenu, _Component);

    function PanelMenu(props) {
        _classCallCheck(this, PanelMenu);

        var _this = _possibleConstructorReturn(this, (PanelMenu.__proto__ || Object.getPrototypeOf(PanelMenu)).call(this, props));

        _this.state = {};
        return _this;
    }

    _createClass(PanelMenu, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            var divClass = (0, _classnames2.default)('ui-panelmenu ui-widget', this.props.styleClass);

            return _react2.default.createElement(
                'div',
                { className: divClass, style: this.props.style, ref: function ref(el) {
                        return _this2.container = el;
                    } },
                this.props.model && this.props.model.map(function (item, index) {
                    return _react2.default.createElement(PanelMenuItem, { item: item, index: index, length: _this2.props.model.length, key: index });
                })
            );
        }
    }]);

    return PanelMenu;
}(_react.Component);

PanelMenu.defaultProps = {
    model: null,
    style: null,
    styleClass: null
};
PanelMenu.propsTypes = {
    model: _propTypes2.default.array,
    style: _propTypes2.default.any,
    styleClass: _propTypes2.default.string
};

var PanelMenuItem = exports.PanelMenuItem = function (_Component2) {
    _inherits(PanelMenuItem, _Component2);

    function PanelMenuItem(props) {
        _classCallCheck(this, PanelMenuItem);

        var _this3 = _possibleConstructorReturn(this, (PanelMenuItem.__proto__ || Object.getPrototypeOf(PanelMenuItem)).call(this, props));

        _this3.item = _this3.props.item;
        _this3.state = { expanded: _this3.item.expanded };
        return _this3;
    }

    _createClass(PanelMenuItem, [{
        key: 'itemClick',
        value: function itemClick(event, item) {
            if (item.disabled) {
                event.preventDefault();
                return;
            }
            this.setState({ expanded: !this.state.expanded });
            if (!item.url) {
                event.preventDefault();
            }

            if (item.command) {
                item.command({
                    originalEvent: event,
                    item: item
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            var subPanel = (0, _classnames2.default)('ui-panelmenu-content-wrapper', { 'ui-panelmenu-content-wrapper-overflown': !this.state.expanded });
            var iconClass = (0, _classnames2.default)('ui-menuitem-icon fa fa-fw', this.item.icon ? this.item.icon : null);
            var panelIcon = (0, _classnames2.default)('ui-panelmenu-icon fa', { 'fa-caret-right': !this.state.expanded }, { ' fa-caret-down': this.state.expanded });
            var itemClass = (0, _classnames2.default)('ui-widget ui-panelmenu-header ui-state-default', this.item.styleClass, { 'ui-state-active': this.state.expanded }, { 'ui-state-disabled': this.item.disabled }, { 'ui-corner-top': this.props.index === 0 }, { 'ui-corner-bottom': this.props.index === this.props.length - 1 && !this.state.expanded });

            return _react2.default.createElement(
                'div',
                { className: 'ui-panelmenu-panel', key: this.props.index },
                _react2.default.createElement(
                    'div',
                    { className: itemClass, style: this.item.style },
                    this.item.url ? _react2.default.createElement(
                        'a',
                        { href: this.item.url || '#', className: { 'ui-panelmenu-headerlink-hasicon': this.item.icon }, target: this.item.target, onClick: function onClick(event) {
                                return _this4.itemClick(event, _this4.item);
                            } },
                        this.item.items && _react2.default.createElement('span', { className: panelIcon }),
                        this.item.icon && _react2.default.createElement('span', { className: iconClass }),
                        _react2.default.createElement(
                            'span',
                            { className: 'ui-menuitem-text' },
                            this.item.label
                        )
                    ) : _react2.default.createElement(
                        'a',
                        { href: '#', className: { 'ui-panelmenu-headerlink-hasicon': this.item.icon }, target: this.item.target, onClick: function onClick(event) {
                                return _this4.itemClick(event, _this4.item);
                            } },
                        this.item.items && _react2.default.createElement('span', { className: panelIcon }),
                        this.item.icon && _react2.default.createElement('span', { className: iconClass }),
                        _react2.default.createElement(
                            'span',
                            { className: 'ui-menuitem-text' },
                            this.item.label
                        )
                    )
                ),
                this.item.items && _react2.default.createElement(
                    'div',
                    { className: subPanel, style: { height: !this.state.expanded ? '0px' : 'auto',
                            transitionTimingFunction: 'cubic-bezier(0.86, 0, 0.07, 1)', transitionDuration: '400ms' } },
                    _react2.default.createElement(
                        'div',
                        { className: 'ui-panelmenu-content ui-widget-content' },
                        _react2.default.createElement(SubItem, { item: this.item, expanded: true })
                    )
                )
            );
        }
    }]);

    return PanelMenuItem;
}(_react.Component);

PanelMenuItem.defaultProps = {
    item: null,
    index: null,
    length: null
};
PanelMenuItem.propsTypes = {
    item: _propTypes2.default.any,
    index: _propTypes2.default.any,
    length: _propTypes2.default.any
};

var SubItem = function (_Component3) {
    _inherits(SubItem, _Component3);

    function SubItem(props) {
        _classCallCheck(this, SubItem);

        var _this5 = _possibleConstructorReturn(this, (SubItem.__proto__ || Object.getPrototypeOf(SubItem)).call(this, props));

        _this5.item = _this5.props.item;
        _this5.state = {};
        return _this5;
    }

    _createClass(SubItem, [{
        key: 'render',
        value: function render() {
            var _this6 = this;

            return _react2.default.createElement(
                'ul',
                { className: 'ui-menu-list ui-helper-reset', style: { height: this.props.expanded ? 'auto' : '0px',
                        transitionTimingFunction: 'cubic-bezier(0.86, 0, 0.07, 1)', transitionDuration: '400ms' } },
                this.item.items && this.item.items.map(function (child, index) {
                    return _react2.default.createElement(Item, { child: child, tabIndex: _this6.item.expanded, index: index, key: index });
                })
            );
        }
    }]);

    return SubItem;
}(_react.Component);

SubItem.defaultProps = {
    item: null,
    expanded: null
};
SubItem.propsTypes = {
    item: _propTypes2.default.any,
    expanded: _propTypes2.default.bool
};

var Item = function (_Component4) {
    _inherits(Item, _Component4);

    function Item(props) {
        _classCallCheck(this, Item);

        var _this7 = _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).call(this, props));

        _this7.child = _this7.props.child;
        _this7.state = { expanded: _this7.child.expanded };
        return _this7;
    }

    _createClass(Item, [{
        key: 'itemClick',
        value: function itemClick(event, item) {
            if (item.disabled) {
                event.preventDefault();
                return;
            }
            this.setState({ expanded: !this.state.expanded });
            if (!item.url) {
                event.preventDefault();
            }

            if (item.command) {
                item.command({
                    originalEvent: event,
                    item: item
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this8 = this;

            var panelClass = (0, _classnames2.default)('ui-panelmenu-icon fa fa-fw', { 'fa-caret-right': !this.state.expanded }, { ' fa-caret-down': this.state.expanded });
            var iconClass = (0, _classnames2.default)('ui-menuitem-icon fa fa-fw', this.child.icon ? this.child.icon : null);
            var aClass = (0, _classnames2.default)('ui-menuitem-link ui-corner-all', { 'ui-menuitem-link-hasicon': this.child.icon && this.child.items, 'ui-state-disabled': this.child.disabled });
            var listClass = (0, _classnames2.default)('ui-menuitem ui-corner-all', { 'ui-menu-parent': this.child.items }, this.child.styleClass);
            return this.child.separator ? _react2.default.createElement('li', { className: 'ui-menu-separator ui-widget-content', key: this.props.index }) : _react2.default.createElement(
                'li',
                { className: listClass, style: this.child.style, key: this.props.index },
                this.child.url ? _react2.default.createElement(
                    'a',
                    { className: aClass, href: this.child.url || '#', target: this.child.target, tabIndex: !this.props.tabIndex ? null : '-1', onClick: function onClick(event) {
                            _this8.itemClick(event, _this8.child);
                        } },
                    this.child.items && _react2.default.createElement('span', { className: panelClass }),
                    this.child.icon && _react2.default.createElement('span', { className: iconClass }),
                    _react2.default.createElement(
                        'span',
                        { className: 'ui-menuitem-text' },
                        this.child.label
                    )
                ) : _react2.default.createElement(
                    'a',
                    { className: aClass, href: '#', target: this.child.target, tabIndex: !this.props.tabIndex ? null : '-1', onClick: function onClick(event) {
                            _this8.itemClick(event, _this8.child);
                        } },
                    this.child.items && _react2.default.createElement('span', { className: panelClass }),
                    this.child.icon && _react2.default.createElement('span', { className: iconClass }),
                    _react2.default.createElement(
                        'span',
                        { className: 'ui-menuitem-text' },
                        this.child.label
                    )
                ),
                this.child.items && _react2.default.createElement(SubItem, { item: this.child, expanded: this.state.expanded })
            );
        }
    }]);

    return Item;
}(_react.Component);

Item.defaultProps = {
    child: null,
    tabIndex: null,
    index: null
};
Item.propsTypes = {
    child: _propTypes2.default.any,
    tabIndex: _propTypes2.default.bool,
    index: _propTypes2.default.any
};