'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Password = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DomHandler = require('../utils/DomHandler');

var _DomHandler2 = _interopRequireDefault(_DomHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Password = exports.Password = function (_Component) {
    _inherits(Password, _Component);

    function Password(props) {
        _classCallCheck(this, Password);

        var _this = _possibleConstructorReturn(this, (Password.__proto__ || Object.getPrototypeOf(Password)).call(this, props));

        _this.state = { hidden: true };
        return _this;
    }

    _createClass(Password, [{
        key: 'onInputFocus',
        value: function onInputFocus(event) {
            if (this.props.feedback) {
                this.panel.style.zIndex = _DomHandler2.default.getZindex();
                _DomHandler2.default.removeClass(this.panel, 'ui-helper-hidden');
                _DomHandler2.default.absolutePosition(this.panel, this.container);
                _DomHandler2.default.fadeIn(this.panel, 250);
                if (event.target.value.length === 0) this.info.textContent = this.props.promptLabel;
            }
        }
    }, {
        key: 'onInputBlur',
        value: function onInputBlur(event) {
            _DomHandler2.default.addClass(this.panel, 'ui-helper-hidden');
        }
    }, {
        key: 'onKeyup',
        value: function onKeyup(event) {
            var value = event.target.value,
                label = null,
                meterPos = null;

            if (value.length === 0) {
                label = this.props.promptLabel;
                meterPos = '0px 0px';
            } else {
                var score = this.testStrength(value);

                if (score < 30) {
                    label = this.props.weakLabel;
                    meterPos = '0px -10px';
                } else if (score >= 30 && score < 80) {
                    label = this.props.mediumLabel;
                    meterPos = '0px -20px';
                } else if (score >= 80) {
                    label = this.props.strongLabel;
                    meterPos = '0px -30px';
                }
            }

            this.meter.style.backgroundPosition = meterPos;
            this.info.textContent = label;
        }
    }, {
        key: 'testStrength',
        value: function testStrength(str) {
            var grade = 0;
            var val = void 0;

            val = str.match('[0-9]');
            grade += this.normalize(val ? val.length : 1 / 4, 1) * 25;

            val = str.match('[a-zA-Z]');
            grade += this.normalize(val ? val.length : 1 / 2, 3) * 10;

            val = str.match('[!@#$%^&*?_~.,;=]');
            grade += this.normalize(val ? val.length : 1 / 6, 1) * 35;

            val = str.match('[A-Z]');
            grade += this.normalize(val ? val.length : 1 / 6, 1) * 30;

            grade *= str.length / 8;

            return grade > 100 ? 100 : grade;
        }
    }, {
        key: 'normalize',
        value: function normalize(x, y) {
            var diff = x - y;

            if (diff <= 0) return x / y;else return 1 + 0.5 * (x / (x + y / 4));
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var password = _react2.default.createElement('input', { type: 'password', className: 'ui-dropdown-filter ui-inputtext ui-widget ui-state-default ui-corner-all',
                onFocus: this.onInputFocus.bind(this), onBlur: this.onInputBlur.bind(this),
                onChange: this.onKeyup.bind(this), ref: function ref(el) {
                    _this2.container = el;
                } });

            return _react2.default.createElement(
                'div',
                { className: 'ui-inputtext ui-corner-all ui-widget ui-state-filled' },
                password,
                _react2.default.createElement(
                    'div',
                    { className: 'ui-password-panel ui-widget ui-state-highlight ui-password-panel-overlay ui-helper-hidden',
                        ref: function ref(el) {
                            _this2.panel = el;
                        } },
                    _react2.default.createElement('div', { className: 'ui-password-meter', ref: function ref(el) {
                            _this2.meter = el;
                        } }),
                    _react2.default.createElement('div', { className: 'ui-password-info', ref: function ref(el) {
                            _this2.info = el;
                        } })
                )
            );
        }
    }]);

    return Password;
}(_react.Component);

Password.defaultProps = {
    value: null,
    promptLabel: 'Please enter a password',
    weakLabel: 'Weak',
    mediumLabel: 'Medium',
    strongLabel: 'Strong',
    feedback: true
};
Password.propTypes = {
    value: _propTypes2.default.any,
    promptLabel: _propTypes2.default.string,
    weakLabel: _propTypes2.default.string,
    mediumLabel: _propTypes2.default.string,
    strongLabel: _propTypes2.default.string,
    feedback: _propTypes2.default.bool
};